import { Model } from "sequelize";
export declare enum HookEvent {
    PackageStar = "package:star",
    PackageUnstar = "package:unstar",
    PackagePublish = "package:publish",
    PackageUnpublish = "package:unpublish",
    PackageOwner = "package:owner",
    PackageOwnerRm = "package:owner-rm",
    PackageDistTag = "package:dist-tag",
    PackageDistTagRm = "package:dist-tag-rm",
    PackageDeprecated = "package:deprecated",
    PackageUndeprecated = "package:undeprecated",
    PackageChange = "package:change"
}
interface HookChangeObject {
    version?: string;
    "dist-tag"?: string;
    user?: string;
    maintainer?: string;
    deprecated?: string;
}
interface HookPayload {
    event: HookEvent;
    name: string;
    type: "package" | "owner" | "scope";
    version: string;
    hookOwner?: {
        username: string;
    };
    payload?: object;
    change: HookChangeObject;
    time: number;
}
export declare class Hook extends Model {
    static getUserHooks(ownerId: string): Promise<Hook[]>;
    static notifyHooks(type: "package" | "owner" | "scope", name: string, payload: HookPayload): Promise<void>;
}
export {};
